<?php
// PHP script by newquayweather.com
// 
// Version 1.00 - 15th Jan 15 -- Initial release
// Version 1.10 - 30th Jan 15 -- Extra background images added
//
// Notes, Please read
// This displays the last quarter graph
// Example my home page at http://www.newquayweather.com/wxsunspots.php
//
// Change settings to match your server, jpgraphs dir etc and upload
// into your wxgraphs directory, 
// Cache file, uploaded to sunspots year directory, script will create year directory
// and can be called with 
//
// <img src="./wxgraphs/sunspots-qtr.php" alt="Sunspots quarter" border="0"/>

// There is an issue at start of quarter as there will be no data, working on this
//
// Change settings to match your server
// 

  $Version = 'sunspotquarter.php V1.10 - 30-Jan-2015';
//
if (!file_exists("graphsconf.php")) include("error_msg.php");
include ("graphsconf.php");
if (!file_exists($jploc."jpgraph.php")) {
  $string = "Unable to find JPGraph files";
  create_image1($string,$jploc);
  exit;
}

include ($jploc."jpgraph.php");

include ($jploc."jpgraph_line.php");

// cacheName is name of file used to store cached webpage
// Change to match your server and in the check year dir exists below, may look something like
  $cacheName = "/home/XXXXX/public_html/XXXXX/sunspots/".date("Y")."/sunspotsqtr.txt";
  $refetchSeconds = 14400;     // refetch every nnnn seconds 3600 = 1 hour, 14400 = 4 hours, 28800 = 8 hours etc
  
  // check year dir exists, if not create, change to match your server
if (!is_dir('/home/XXXXX/public_html/XXXXX/sunspots/'.date("Y"))) {
    mkdir('/home/XXXXXX/public_html/XXXXXX/sunspots/'.date("Y"));
}

//
// Sunspot daily totals and background image url's
// 
// $ftp_server = "http://legacy-www.swpc.noaa.gov/ftpdir/latest/DSD.txt";
  $ftp_server = "ftp://ftp.swpc.noaa.gov/pub/indices/quar_DSD.txt";
//
// Choose only one for background image, un comment one, you will have to delete cached copy, bgqtrimage.jpg
//
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/hmi_igr/512/latest.jpg"; // background MDI image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/c2/512/latest.jpg"; // SOHO LASCO C2 Latest Image
  $bgimageurl="https://soho.nascom.nasa.gov/data/realtime/eit_304/512/latest.jpg"; // EIt 304 lastest image 11-04-2022
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/eit_304/512/latest.jpg"; // EIT_304 latest image
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/synoptic/sunspots_earth/mdi_sunspots.jpg"; // background image to graphs
// cache image
  $bgimage="${hostloc}sunspots/bgqtrimage.jpg"; // background cache image path
//
$lines = count(file($ftp_server));  

// end of settings

// background image
if (file_exists($bgimage) and filemtime($bgimage) + $refetchSeconds > time()) {
//      echo "<!-- using Cached version of jpg -->\n";
  $bgimage = "${hostloc}sunspots/bgqtrimage.jpg";
    } else {
$ch = curl_init($bgimageurl);
$fp = fopen($bgimage, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);
fclose($fp);
}
// end background image 	
//sunspot data
if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {
      $text = implode('', file($cacheName));
 } else {
 $ctx = stream_context_create(array('http' => array('timeout' => 10)));
 $text=@file_get_contents($ftp_server, 0, $ctx);

  $line = 2;      // line number starting point
  $lineend = $lines-11;  // last line



file_put_contents($cacheName, ""); //zero file
while ($line < $lineend) {
$split = preg_split("/[\n]/", $text, -1, 0 );
$lastline = count($split)-$line;
$last = $split[$lastline];
$last = preg_replace('/\s\s+/', ' ', $last)."\n";
file_put_contents($cacheName, $last, FILE_APPEND);
 $line++;
}
}

// arrays
$y = array();
$a = array();

readsunspotfile($cacheName,$a,$y);

// Here we create an aray for the y-values
//$y = array(fgets($handle[$yy]));
//=================================================================================================
//here we create the labels for the x-axis depending month and year
//so if we are in March we must show the last day of Feb normally 28 or 29 and the following
//label must be 01
//same for moths with 30 days (last day = 30 next label must be 01 and not 31
//we need 31 labels because we have 31 datapoints
//==================================================================================================
//
// Create the graph. These two calls are always required
$graph = new Graph(512,572,"auto",30);	
$graph->SetScale("textlin");
$graph->yaxis->scale->SetAutoMin(0); 


$graph->yscale->SetGrace(2);
$graph->SetMargin(25,20,25,70);
$graph->ygrid->Show(false); 
$graph->SetShadow();  //uncomment to add shadow

// Graph colors
$graph->SetBackgroundGradient('black','black',GRAD_HOR,BGRAD_PLOT);
$graph->SetMarginColor("black");
$graph->SetFrame(true,'black',1);

// Create a line plot
$lplot = new LinePlot($y);
$lplot->SetColor('yellow'); // color of y-axis graph line
$lplot->SetWeight(2);
$graph->Add($lplot);
$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);
// End comment out

// Setup the titles
$graph->title->SetFont(FF_ARIAL,FS_BOLD,12);
$graph->title->Set("Sunspots - Current Quarter");
$graph->title->SetColor("orange"); 


//x-axis
$graph->xaxis->title->SetFont(FF_ARIAL,FS_BOLD,10);
$graph->xaxis->title->SetColor("$xtextcolour");
$graph->xaxis->SetTickLabels($a); 
$graph->xaxis->SetLabelAngle(80);
$graph->xaxis->SetLabelMargin(5); 
$graph->xaxis->SetTextLabelInterval(3);
$graph->xaxis->SetPos("min"); 
$graph->xaxis->SetFont(FF_ARIAL,FS_BOLD,8); 
$graph->xaxis->SetColor("$xtextcolour");
$graph->xaxis->HideTicks(true,false); 
$graph->xaxis->SetTickSide(SIDE_BOTTOM); 
$graph->xaxis->SetColor('white','orange'); 

//y-axis
$graph->yaxis->SetFont(FF_ARIAL,FS_BOLD,8);
$graph->yaxis->scale->SetGrace(5);
$graph->yaxis->SetLabelMargin(5); 
$graph->yaxis->SetColor('white','orange'); 

// Display the graph
$graph->Stroke();


// ----------------------------functions ----------------------------------- 
 
 
  
function readsunspotfile($aFile, &$aYears, &$aSunspots) {
	    $lines = @file($aFile,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
    if( $lines === false ) {
        throw new JpGraphException('Can not read sunspot data file.');
    }

   foreach( $lines as $line => $datarow ) {
//   $split = preg_split("/[\n]/", $datarow, -1, 0);

 $dayspots = explode(" ", $datarow);
 $yr = $dayspots[0]; // year
 $mth = $dayspots[1]; // month
 $dy = $dayspots[2]; // day
 $spots = $dayspots[4]; // spots
 $aYears[] = $dy."-".$mth."-".$yr;
 $aSunspots[] = $spots;
    }
}

// --------------end of functions ---------------------------------------
?>
